/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "ip.h"


//############################################################################
//Diese Routine erzeugt ein IP Packet
/**
	\param bSwap swap source and dst addr
*/
void Make_IP_Header (char *buffer, uint8_t bSwap)
//############################################################################
{
	//Variablen zur Berechnung der Checksumme
	unsigned int result16;
	
	if (bSwap)
	{
		struct Ethernet_Header *ethernet;
		ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];

		for (unsigned char a = 0; a < 6; a++)
			{
			//MAC Destadresse wird geschrieben mit MAC Sourceadresse
			ethernet->EnetPacketDest[a] = ethernet->EnetPacketSrc[a];
			//Meine MAC Adresse wird in Sourceadresse geschrieben
			ethernet->EnetPacketSrc[a] = mymac[a];
			}
	}
	
	struct IP_Header *ip;
	ip = (struct IP_Header *)&buffer[IP_OFFSET];
	
	if (bSwap)
	{
		//change DST IP to SRC IP and SRC IP to own IP to reply
		ip->IP_Destaddr	= ip->IP_Srcaddr;
		ip->IP_Srcaddr	= *((unsigned long *)&MYIP[0]);
	}
		
	//Berechnung der IP Checksumme
	//Alle Daten im IP Header werden addiert checksum wird deshalb
	//ersteinmal auf null gesetzt
	ip->IP_Hdr_Cksum = 0x0000;
	
	//Berechnung der IP Header lnge	
	result16 = (ip->IP_Vers_Len & 0x0F) << 2;

	//jetzt wird die Checksumme berechnet
	result16 = checksum (&ip->IP_Vers_Len, result16, 0);

	//schreibt Checksumme ins Packet
	ip->IP_Hdr_Cksum = ((result16 & 0xFF00) >> 8)|((result16 & 0x00FF)<<8);
}

/**	\param *IP 4 chars of IP
	\return 32 bit IP in network order
*/
uint32_t IpCharToU32(const char *IP)
{
	return ( (((uint32_t)IP[3])<<24) + (((uint32_t)IP[2])<<16) + 
		(((uint32_t)IP[1])<<8) + ((uint32_t)IP[0]) );
}

void IpU32ToChar(uint32_t u32_IP, char *IP)
{

}


uint16_t htons(uint16_t x)
{
	uint8_t *s = (uint8_t *) &x;
	return (uint16_t)(s[0] << 8 | s[1]);
}
